<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\GraficoService;

class GraficoController extends FMCrud{
   protected $DashboardService;
   
    public function __construct($crudService, $environment, GraficoService $GraficoService) {
        parent::__construct($crudService, $environment);
        $this->GraficoService = $GraficoService;
    }
  
  public function getUnidade(DTO\Request $request, DTO\Response $response) {
    $dadosUnidade = $this->GraficoService->getUnidade();
    $dtsVal = new DataSet('dados', $dadosUnidade);
    $response->addDataSet($dtsVal);
  }
  
  public function getAtividades(DTO\Request $request, DTO\Response $response) {
    $dadosAtividades = $this->GraficoService->getAtividades();
    $dtsVal = new DataSet('dados', $dadosAtividades);
    $response->addDataSet($dtsVal);
  }
  
  public function getDadosGraficosGerados(DTO\Request $request, DTO\Response $response) {
    $param = $request->getParameters();
    $dadosAtividades = $this->GraficoService->getDadosGraficosGerados($param);
    $dtsVal = new DataSet('dados', $dadosAtividades);
    $response->addDataSet($dtsVal);
  }
  
  public function getFonteDados(DTO\Request $request, DTO\Response $response) {
    $dados = $this->GraficoService->getFonteDados();
    $dtsVal = new DataSet('dados', $dados);
    $response->addDataSet($dtsVal);
  }
  
  public function getMetricas(DTO\Request $request, DTO\Response $response) {
    $param = $request->getParameters();
    $dados = $this->GraficoService->getMetricas($param);
    $dtsVal = new DataSet('dados', $dados);
    $response->addDataSet($dtsVal);
  }

  public function insertGrafico(DTO\Request $request, DTO\Response $response) {
    
    $param = $request->getParameters();
    $dados = $this->GraficoService->insertGrafico($param);
    $dtsVal = new DataSet('resposta', array('retorno' => $dados));
    $response->addDataSet($dtsVal);
  }
  
  public function deletaGraficoGerado(DTO\Request $request, DTO\Response $response) {
    $param = $request->getParameters();
    $resposta = $this->GraficoService->deletaGraficoGerado($param);
    $dtsVal = new DataSet('resposta', array('retorno' => $resposta));
    $response->addDataSet($dtsVal);
  }
  
  public function consultaDinamica(DTO\Request $request, DTO\Response $response) {
    $param = $request->getParameters();
    $resposta = $this->GraficoService->consultaDinamica($param);
    $dtsVal = new DataSet('resposta', $resposta);
    $response->addDataSet($dtsVal);
  }
  
  public function buscaDadosGrafRel(DTO\Request $request, DTO\Response $response) {
    $param = $request->getParameters();
    $resposta = $this->GraficoService->buscaDadosGrafRel($param);
    $dtsVal = new DataSet('resposta', $resposta);
    $response->addDataSet($dtsVal);
  }
  
  public function getDadosEditGrafico(DTO\Request $request, DTO\Response $response) {
    $param = $request->getParameters();
    $resposta = $this->GraficoService->getDadosEditGrafico($param);
    $dtsVal = new DataSet('resposta', $resposta);
    $response->addDataSet($dtsVal);
  }
  
  public function copiaGrafico(DTO\Request $request, DTO\Response $response) {
    $param = $request->getParameters();
    $resposta = $this->GraficoService->copiaGrafico($param);
    $dtsVal = new DataSet('resposta', array('retorno' => $resposta));
    $response->addDataSet($dtsVal);
  }
  
  public function atualizaGrafico(DTO\Request $request, DTO\Response $response) {
    $param = $request->getParameters();
    $resposta = $this->GraficoService->atualizaGrafico($param);
    $dtsVal = new DataSet('resposta', array('retorno' => $resposta));
    $response->addDataSet($dtsVal);
  }
}
?>